//=============================================
//      v.1.0
//  by Alex Pan, Penza, Russia
//============================================
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

//============================================
//
int *numfileword;              //     
int counter=1;                 // -   
char filen[256]="muller7.dwa"; //  
int tran=1;                    //  ?

//============================================
//      
void ErrorMessage(int nom,char *c)
{
    switch(nom){
        case 0:strcpy(c," ");break;
        case 1:strcpy(c,"    .     -h");break;
        case 2:strcpy(c,"  ");break;
        case 3:strcat(strcat(strcpy(c,"  '"),filen),"'  ");break;
        case 4:strcpy(c," ");break;
        case 5:strcpy(c,"    .   -h");break;
        default:strcpy(c," ");
    }
}

//============================================
//     
void ErrorShow(char c[])
{
    printf(": %s\n",c);
}

//============================================
//    
void ComStr(char *par)
{   char err[256];

    if(par[1]=='h'||par[1]=='H'||par[1]=='?'){
        printf(" '-    '  1.0 by Alex Pan (flex@land.ru), Penza, Russia (13.04.2003)\n");
        printf("\n   :\n");
        printf("V.K.Muller English-Russian Dictionary, 7 Edition; 'State Publishing House of Foreign and National Dictionaries' Moscow 1961\n");
        printf("    muller7.dwa (    'slowo'   (wolf@gambit.msk.su))\n");
        printf("     muller7.dwb\n");
        printf("\n:\n");
        printf("dict [-h] [-t] [-p -] [...]\n");
        printf("\n:\n");
        printf("-h  --  \n");
        printf("-t  --    (     )\n");
        printf("-p  --     -\n");
        printf("\n:\n");
        printf("./dict -h                 <-   \n");
        printf("./dict go                 <-    'go'\n");
        printf("./dict go home            <-    'go'  'home'\n");
        printf("./dict 'go home'          <-    'go home'\n");
        printf("./dict -t go home         <-    'go'  'home'   \n");
        printf("./dict -h -t go           <-          'go'\n");
        printf("./dict -pmuller24.dwa go  <-    'go'   muller24.dwa\n");
        printf("\n:        (  ...)   5 \n");
        return;
    }
    if(par[1]=='p'||par[1]=='P'){strcpy(filen,&par[2]);return;}
    if(par[1]=='t'||par[1]=='T'){tran=0;return;}
    ErrorMessage(5,err);ErrorShow(err);
}

//---------------------------------------
//     
void UpperCase(char *bilo, char stalo[])
{int i,k;
  k=strlen(bilo);
  if(k==0)return;
  for(i=0;i<=(k+1);i++)stalo[i]=toupper(bilo[i]);
  return;
}

//============================================
//        
#define BUFSIZE 2048
int NumFile()
{   FILE *fp;
    char buf[BUFSIZE];
    int n,i,cou=0;

    //    
    fp=fopen(filen,"r");if(fp==NULL)return 3;
    counter=1;
    do{
        n=fread(buf,1,BUFSIZE,fp);
        for(i=0;i<n;i++)if(buf[i]==0x0A)counter++;
    }while(n==BUFSIZE);
    //  
    numfileword=(int *)malloc(counter*sizeof(int));
    if(!numfileword){fclose(fp);return 4;}
    //  
    fseek(fp,0,0);
    numfileword[0]=0;
    counter=0;
    do{
        n=fread(buf,1,BUFSIZE,fp);
        for(i=0;i<n;i++)if(buf[i]==0x0A)numfileword[counter++]=cou*BUFSIZE+i+1;
        cou++;
    }while(n==BUFSIZE);
    fclose(fp);
    return 0;
}

//============================================
//    (   ,    )
int FindWord(char wordx[])
{   FILE *fp;
    char buf[512],mword[256],word[256];
    int k,i;

    strcpy(word,wordx);UpperCase(word,word);
    fp=fopen(filen,"r");if(fp==NULL)return 3;
    for(i=0;i<counter;i++){
        fseek(fp,numfileword[i],0);
        fread(buf,1,512,fp);
        k=strstr(buf,"  ")-buf;
        memset(mword,0,k+1);memcpy(mword,buf,k);
        UpperCase(mword,mword);
        if(!strcmp(word,mword)){fclose(fp);return i;}
    }
    fclose(fp);
    return -1;
}

//============================================
//        
int ShowWord(int nom)
{   FILE *fp;
    char *buf,*b;
    int k,siz,i;

    //    
    siz=numfileword[nom+1]-numfileword[nom]-1;
    fp=fopen(filen,"r");if(fp==NULL)return 3;
    fseek(fp,numfileword[nom],0);
    buf=(char *)malloc((siz+1)*sizeof(char));if(!buf){fclose(fp);return 4;}
    memset(buf,0,siz+1);
    fread(buf,1,siz,fp);
    fclose(fp);
    //   
    k=strstr(buf,"  ")-buf;buf[k]=0;printf("%s\n",buf);// 
    memmove(&buf[0],&buf[k+2],siz-k);siz=siz-k-2;
    b=strstr(buf,"]");
    if(b){
        k=b-buf;buf[k+1]=0;if(tran)printf("%s\n",buf);//  (  )
        memmove(&buf[0],&buf[k+2],siz-k);siz=siz-k-2;
    }
    i=0;k=0;
    while(buf[i]){
        if(buf[i]==' ')k=i;
        if(((buf[i]=='>')&&(k)) || ((buf[i]=='.')&&(isdigit(buf[i-1]))&&(k))){
            buf[k]=0;printf("%s\n",buf);memmove(&buf[0],&buf[k+1],siz-k+1);siz=siz-k+1;k=0;i=0;
        }
        i++;
    }
    printf("%s\n\n\n",buf);//
    free(buf);
    return 0;
}

//============================================
//  
int main(int argc,char **argv)
{   char err[256];
    int numword,errn,first=0;

    if(argc==1){ErrorMessage(1,err);ErrorShow(err);return 0;}
    printf("\n");
    for(int i=1;i<argc;i++){
        if(argv[i][0]=='-'){ComStr(argv[i]);continue;}
        if(!first){first++;errn=NumFile();if(errn){ErrorMessage(errn,err);ErrorShow(err);break;}}
        numword=FindWord(argv[i]);
        if(numword==-1){printf("%s\n",argv[i]);ErrorMessage(2,err);ErrorShow(err);printf("\n\n");continue;}
        errn=ShowWord(numword);
        if(errn){ErrorMessage(errn,err);ErrorShow(err);break;}
    }
    if(numfileword)free(numfileword);
    return 0;
}
